module     p0_ddbar_emepg_d71h2l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity2/d71h2l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_config, only: ki
   use p0_ddbar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d71
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh2
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      real(ki) :: t25
      real(ki) :: t26
      real(ki) :: t27
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t25 = dotproduct(k2, qshift)
      t26 = dotproduct(qshift, qshift)
      t27 = dotproduct(k5, qshift)
      t1 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t2 = (spvak1k4(1)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-sp&
      &vak1k4(4)*qshift(4))
      t3 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t4 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t5 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb71n24+t1*abb71n40+t2*abb71n41+t25*abb71n39+t25*t25*abb7&
         &1n34+t26*abb71n36+t27*abb71n38+t3*abb71n42+t1*t25*abb71n31+t1*t26*abb7&
         &1n48+t1*t27*abb71n29+t1*t3*abb71n26+t2*t25*abb71n27+t2*t26*abb71n50+t2&
         &*t27*abb71n28+t2*t3*abb71n25+t25*t26*abb71n46+t25*t27*abb71n32+t25*t3*&
         &abb71n35+t26*t3*abb71n43+t3*t4*abb71n30+t3*t5*abb71n33+t3*t4*t6*abb71n&
         &52)
         return
      end if
      t7 = k2(iv1)
      t8 = k5(iv1)
      t9 = qshift(iv1)
      t10 = spvak1k4(iv1)
      t11 = spvak1k5(iv1)
      t12 = spvak2k5(iv1)
      t13 = spvak1k2(iv1)
      t14 = spvak5k2(iv1)
      t15 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb71n41+t11*abb71n40+t12*abb71n42+t7*abb71n39+t8*abb7&
         &1n38+t9*abb71n37+t1*t12*abb71n26+t1*t7*abb71n31+t1*t8*abb71n29+t1*t9*a&
         &bb71n49+t10*t25*abb71n27+t10*t26*abb71n50+t10*t27*abb71n28+t10*t3*abb7&
         &1n25+t11*t25*abb71n31+t11*t26*abb71n48+t11*t27*abb71n29+t11*t3*abb71n2&
         &6+t12*t2*abb71n25+t12*t25*abb71n35+t12*t26*abb71n43+t12*t4*abb71n30+t1&
         &2*t5*abb71n33+t13*t3*abb71n30+t14*t3*abb71n33+t2*t7*abb71n27+t2*t8*abb&
         &71n28+t2*t9*abb71n51+t25*t7*abb71n45+t25*t8*abb71n32+t25*t9*abb71n47+t&
         &26*t7*abb71n46+t27*t7*abb71n32+t3*t7*abb71n35+t3*t9*abb71n44+t12*t4*t6&
         &*abb71n52+t13*t3*t6*abb71n52+t15*t3*t4*abb71n52)
         return
      end if
      t26 = d(iv1,iv2)
      t5 = k2(iv2)
      t16 = k5(iv2)
      t17 = qshift(iv2)
      t18 = spvak1k4(iv2)
      t19 = spvak1k5(iv2)
      t20 = spvak2k5(iv2)
      t21 = t13*t20
      t22 = spvak1k2(iv2)
      t23 = t12*t22
      t24 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t26*abb71n36+t1*t26*abb71n48+t2*t26*abb71n50+t25&
         &*t26*abb71n46+t26*t3*abb71n43+t5*t7*abb71n34)+t21*abb71n30+t23*abb71n3&
         &0+spvak5k2(iv2)*t12*abb71n33+t10*t16*abb71n28+t10*t17*abb71n51+t10*t20&
         &*abb71n25+t10*t5*abb71n27+t11*t16*abb71n29+t11*t17*abb71n49+t11*t20*ab&
         &b71n26+t11*t5*abb71n31+t12*t17*abb71n44+t12*t18*abb71n25+t12*t19*abb71&
         &n26+t12*t5*abb71n35+t14*t20*abb71n33+t16*t7*abb71n32+t17*t7*abb71n47+t&
         &18*t7*abb71n27+t18*t8*abb71n28+t18*t9*abb71n51+t19*t7*abb71n31+t19*t8*&
         &abb71n29+t19*t9*abb71n49+t20*t7*abb71n35+t20*t9*abb71n44+t21*t6*abb71n&
         &52+t23*t6*abb71n52+t5*t8*abb71n32+t5*t9*abb71n47+t12*t24*t4*abb71n52+t&
         &13*t24*t3*abb71n52+t15*t20*t4*abb71n52+t15*t22*t3*abb71n52)
         return
      end if
      t25 = d(iv2,iv3)
      t27 = d(iv1,iv3)
      t1 = spvak2k5(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak1k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(k2(iv3)*t26*abb71n46+spvak1k4(iv3)*t26*abb71n50+&
         &spvak1k5(iv3)*t26*abb71n48+t1*t26*abb71n43+t10*t25*abb71n50+t11*t25*ab&
         &b71n48+t12*t25*abb71n43+t18*t27*abb71n50+t19*t27*abb71n48+t20*t27*abb7&
         &1n43+t25*t7*abb71n46+t27*t5*abb71n46)+t2*t21*abb71n52+t2*t23*abb71n52+&
         &t1*t13*t24*abb71n52+t1*t15*t22*abb71n52+t12*t24*t3*abb71n52+t15*t20*t3&
         &*abb71n52)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d71:
   subroutine     reconstruct_d71(coeffs)
      use p0_ddbar_emepg_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_71:
      coeffs%coeffs_71%c0 = derivative(czip)
      coeffs%coeffs_71%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_71%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_71%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_71%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_71%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_71%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_71%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_71%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_71%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_71%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_71%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_71%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_71%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_71%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_71%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_71%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_71%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_71%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_71%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_71%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_71%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_71%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_71%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_71%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_71%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_71%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_71%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_71%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_71%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_71%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_71%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_71:
   end subroutine reconstruct_d71
!---#] subroutine reconstruct_d71:
end module p0_ddbar_emepg_d71h2l1d
