module     p3_uubar_emepg_scalar_cache
   use precision, only: ki_sam => ki
   use madds
   implicit none
   save

   private
!---#[ scalar integral cache for samurai:
    logical, public  :: samurai_cache_flag_g0
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_g0
    logical, public :: samurai_cache_flag_d25
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d25
    logical, public :: samurai_cache_flag_d27
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d27
    logical, public :: samurai_cache_flag_d65
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d65
    logical, public :: samurai_cache_flag_d67
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d67
    logical, public :: samurai_cache_flag_d73
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d73
    logical, public :: samurai_cache_flag_d75
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d75
    logical, public :: samurai_cache_flag_d79
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d79
    logical, public  :: samurai_cache_flag_g1
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_g1
    logical, public :: samurai_cache_flag_d71
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d71
    logical, public  :: samurai_cache_flag_g2
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_g2
    logical, public :: samurai_cache_flag_d69
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d69
!---#] scalar integral cache for samurai:

   public :: invalidate_cache
contains
   subroutine invalidate_cache()
      implicit none
      samurai_cache_flag_g0 = .false.
      samurai_cache_flag_d25 = .false.
      samurai_cache_flag_d27 = .false.
      samurai_cache_flag_d65 = .false.
      samurai_cache_flag_d67 = .false.
      samurai_cache_flag_d73 = .false.
      samurai_cache_flag_d75 = .false.
      samurai_cache_flag_d79 = .false.
      samurai_cache_flag_g1 = .false.
      samurai_cache_flag_d71 = .false.
      samurai_cache_flag_g2 = .false.
      samurai_cache_flag_d69 = .false.
   end subroutine invalidate_cache
end module p3_uubar_emepg_scalar_cache